<template>
  <div class="columns four">
    <label for="mobilePhone">Мобильный телефон</label>
    <input type="tel"
           name="мобильный телефон"
           id="mobilePhone"
           v-validate="'required|mobilePhone'"
           :class="getValidateClass('мобильный телефон')"
           v-model="$user.mobilePhone"
           :guide="true"
           ref="mobilePhone"
           placeholder="+7"
           v-mask="'+7(###)###-####'"
           :keepCharPositions="true"
           @input="keyup()"
           autocomplete="off"
           data-code="mobilePhoneIsEmpty, mobilePhoneInvalidFormat, mobilePhoneNotUnique, mobilePhoneDoNotHaveActiveSmsCode, spamProtectionRestriction"
    >
    <validate-message v-show="vErrors.has('мобильный телефон') && !notUnique">
      {{ vErrors.first('мобильный телефон') }}
    </validate-message>
    <validate-message v-show="notUnique">
      Указанный номер уже зарегистрирован. <router-link :to="{name: 'login'}">Перейдите в личный кабинет</router-link>
    </validate-message>
  </div>
</template>

<script>
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'

  export default {
    data () {
      return {
        mobilePhone: ''
      }
    },
    computed: {
      notUnique () {
        if (this.$parent.$parent.mobilePhoneNotUnique) {
          // this.$store.commit('RESET_ERROR')
        }
        return this.$parent.$parent.mobilePhoneNotUnique
      }
    },
    components: {
      ValidateMessage
    },
    mixins: [
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      IndicatorRegistration,
      ErrorHandleMixin
    ],
    updated () {
      this.$user.validate.step1.contactMobilePhone = Object.keys(this.$validator.flags).reduce((acc, item) => acc && this.$validator.flags[item].valid, true)
    },
    props: {
      params: {
        default () {
          return {
            isColumnClass: 'columns six input-with-button',
            isInputClass: 'canceled',
            isDisbabledInput: true,
            showButton: true
          }
        }
      }
    },
    name: 'contact-mobile-phone',
    methods: {
      keyup () {
        if ([1, 2, 3, 4, 5, 6, 0].includes(parseInt(this.$user.mobilePhone))) {
          this.$user.mobilePhone = '+7('
        } else if (parseInt(this.$user.mobilePhone) === 8) {
          this.$user.mobilePhone = '+7('
        } else if (parseInt(this.$user.mobilePhone) === 9) {
          this.$user.mobilePhone = '+7(9'
        }
      }
    }
  }
</script>


<style scoped lang="scss">
  .disabled {
    color: darkGray;
    cursor: default;
  }

  ::-webkit-input-placeholder { /* Chrome/Opera/Safari */
    color: #DED3D3;
  }

  ::-moz-placeholder { /* Firefox 19+ */
    color: #DED3D3;
  }

  :-ms-input-placeholder { /* IE 10+ */
    color: #DED3D3;
  }

  :-moz-placeholder { /* Firefox 18- */
    color: #DED3D3;
  }
</style>


